
.386p
.MODEL FLAT,STDCALL
locals
jumps
UNICODE=0
include w32.inc


Extrn SetUnhandledExceptionFilter : PROC

Interrupt      equ 5                            ;cislo prerusenia, cisla 1 alebo 3 stazia debugovanie

.DATA

sprava1        db "Detekcia pomocou VxDCALL - VMMCall Get_DDB",0
sprava2        db "Debuger nenasiel",0
sprava3        db "Debuger najdeny",0
odlozESP       dd 0                             ;sem uklada register ESP
predchadzajuca dd 0                             ;sem uklada adresu predchadzajucej obsluhy SEH
Device_ID      dd 202h                          ;VxD ID pre SICE
Device_ID2     dd 7a5Fh                         ;VxD ID pre SIWVID
Device_Name    dd 0                             ;meno VxD nebudeme potrebovat

.CODE
Start:

;----------------------------------------------------------------------------
;NASTAVI SEH PRE PRIPAD CHYBY
;----------------------------------------------------------------------------
                mov  [odlozESP],esp
                push offset chyba
                call SetUnhandledExceptionFilter
                mov  [predchadzajuca], eax
;----------------------------------------------------------------------------

                push edx
                sidt [esp-2]                    ;nacita IDT do stacku
                pop  edx

                add  edx,(Interrupt*8)+4        ;nacita vektor nami pozadovaneho prerusenia


                mov  ebx,[edx]
                mov  bx,word ptr [edx-4]        ;nacita adresu starej obsluhy nami pozadovaneho prerusenia

                lea  edi,InterruptHandler
                mov  [edx-4],di
                ror  edi,16                     ;nastavi novu obsluhu prerusenia
                mov  [edx+2],di

                push ds                         ;ulozi registre koli bezpecnosti
                push es


                int  Interrupt                  ;skoci do Ring0 (nami definovana nova obsluha INT 5h)

                pop  es                         ;obnovi registre
                pop  ds


                mov  [edx-4],bx                 ;nastavi povodnu obsluhu prerusenia (INT 5h)
                ror  ebx,16
                mov  [edx+2],bx


                push eax                        ;ulozi navratovu hodnotu

;----------------------------------------------------------------------------
;NASTAVI PREDCHADZAJUCU OBSLUHU SEH
;----------------------------------------------------------------------------
                push dword ptr [predchadzajuca]
                call SetUnhandledExceptionFilter
;----------------------------------------------------------------------------

                pop  eax                        ;obnovi navratovu hodnotu

                cmp  eax,1                      ;testuje, ci je navratova hodnota 1, ak ano Soft-Ice je aktivny v pamati
                jz   skok                       ;a skoci


continiue:
                call MessageBoxA,0, offset sprava2, offset sprava1,0
                call ExitProcess, -1

skok:

                call MessageBoxA,0, offset sprava3, offset sprava1,0
                call ExitProcess, -1


chyba:                                          ;nova obsluha SEH pre pripad chyby

                mov  esp, [odlozESP]
                push offset continiue
                ret

;-----------------------------------------------------------------------------
;NASA NOVA OBSLUHA INT 5h (bezi v Ring0)
;-----------------------------------------------------------------------------


InterruptHandler:


                mov  eax, Device_ID             ;202h je pre SICE VxD ID
                mov  edi, Device_Name           ;nastavuje sa iba ak nie je zname Device_ID, inak 0 (nas pripad)
;               VMMCall Get_DDB                 ;volanie obsluhy
                db   0cdh, 20h                  ;to je vlastne INT 20h
                dd   000010146H                 ;0001h je typ volania=VMM
                                                ;0146h je volana funkcia Get_DDB


                test ecx,ecx                    ;ecx=DDB alebo 0 ak VxD nie je nainstalovane

                jnz  Debuger_detect             ;ak sa nepodarilo najst Soft-Ice prvou metodou, skusi druhu


                mov  eax, Device_ID2            ;7a5Fh pre SIWVID VxD ID
                mov  edi, Device_Name           ;nastavuje sa iba ak nie je zname Device_ID, inak 0
;               VMMCall Get_DDB                 ;volanie obsluhy
                db   0cdh, 20h                  ;to je vlastne INT 20h
                dd   000010146H                 ;0001h je typ volania=VMM
                                                ;0146h je volana funkcia Get_DDB


                test ecx,ecx                    ;ecx=DDB alebo 0 ak VxD nie je nainstalovane

                jnz  Debuger_detect

                xor  eax,eax                    ;nuluje EAX, na znak, e Soft-Ice nie je aktvny v pamti

                iretd                           ;skok spat do RING3

Debuger_detect:
                xor  eax,eax
                inc  al                         ;nastavi do eax 1 na znak, ze Soft-Ice je aktivny v pamati

                iretd                           ;skok spat do RING3


ends
end Start
