.386
.MODEL FLAT,STDCALL
locals
jumps
UNICODE=0
include w32.inc


;nepotrebujeme ziadne API volanie (koli detekcii, samozrejme na vypis vysledku a ukoncenie programu ich pouzijeme)

.DATA

sprava1         db "Detekovanie tracera pomocou Trap flag",0
sprava3         db "Tracer najdeny",0
sprava2         db "Tracer nenasiel",0
odlozESP        dd 0                            ;sem uklada register ESP
predchadzajuca  dd 0                            ;sem uklada adresu predchadzajucej obsluhy SEH
znacka          db 0                            ;znacka, ci isiel do xhandlera

.CODE
Start:

                call real_start                 ;skoci na realny start programu

;----------------------------------------------------------------------------
;NOVA OBSLUHA SEH PRE PRIPAD CHYBY (xhandler)
;----------------------------------------------------------------------------

                inc  znacka                     ;zvisi eax o 1 na znak, ze nie je tracovany.

                sub  eax,eax                    ;nuluje eax, koli neskorsiemu nastavovaniu povodnej obsluhy SEH

                ret                             ;spat do programu
;----------------------------------------------------------------------------

real_start:
                xor  eax,eax                    ;nuluje register eax

                push dword ptr fs:[eax]         ;ulozi povodnu obsluhu SEH

                mov  fs:[eax], esp              ;nastavi nasu novu obsluhu SEH (preto sme skocili pomocou CALL, aby do stacku ulozil adresu za nim (navratova adresa) a to je nasa nova obsluha SEH

                pushfd                          ;ulozi flag registre

                or   byte ptr [esp+1], 1        ;nastavi Trap flag v Eflags. To znamena, ze spusti EXCEPTION SINGLE STEP a bude volana nasa nova obsluha SEH

                popfd                           ;obnovi flag registre uz s nastavenym Trap flag. Od tohto momentu je cely proces spusteny

                nop                             ;a je volany xhandler

                pop  dword ptr fs:[eax]         ;nastavi povodnu obsluhu SEH

                pop  ebx                        ;vycisti stack

                dec  znacka                     ;znizi znacku o 1, ak bude po znizeni -1 (0FFFFFFFFh), tak tracer je aktivny v pamati, pretoze xhandler nebol volany

                js   skok                       ;a skoci


continiue:
                call MessageBoxA,0, offset sprava2, offset sprava1,0
                call ExitProcess, -1

skok:

                call MessageBoxA,0, offset sprava3, offset sprava1,0
                call ExitProcess, -1



ends
end Start
