.386
.MODEL FLAT,STDCALL
locals
jumps
UNICODE=0
include w32.inc

Extrn SetUnhandledExceptionFilter : PROC
Extrn VirtualQuery                : PROC


.data

sprava1        db "Detekcia API hook funkcie MessageBoxA",0
sprava3        db "API hook najdeny",0
sprava2        db "API hook nenasiel",0
odlozESP       dd 0                             ;sem uklada register ESP
predchadzajuca dd 0                             ;sem uklada adresu predchadzajucej obsluhy SEH

Struktura_pamate:                               ;sem uklada navratove hodnoty API funkcie VirtualQuery
pvBaseAddress  dd 0
pvAllocBase    dd 0
dwAllocProt    dd 0
dwRegionSize   dd 0
dwState        dd 0
dwProtect      dd 0
dwType         dd 0

Vlastnik       db "USER32.DLL",0               ;sem sa zadava, z ktorej DLL pochadza API funkcia, ktoru budeme testovat

.code

Start:

;----------------------------------------------------------------------------
;NASTAVI SEH PRE PRIPAD CHYBY
;----------------------------------------------------------------------------
                mov  [odlozESP],esp
                push offset chyba
                call SetUnhandledExceptionFilter
                mov  [predchadzajuca], eax
;----------------------------------------------------------------------------

                mov  eax, dword ptr [Detekcia+1]
                                                ;hladanie IAT:
                                                ;do registra eax da z instrukcie
                                                ;call MessageBoxA offset skoku
                                                ;na API funkciu MessageBoxA.
                                                ;call MessageBoxA= (E8xxxxxxxx)
                                                ;my vlastne nacitame hodnotu xxxxxxxx

                add  eax, offset Detekcia+5+2   ;pripocita offset zaciatku tabulky skokov
                                                ;+5=call MessageBoxA= (E8xxxxxxxx)
                                                ;+2=jmp prva_API_funkcia(FF25xxxxxxxx)

                mov  eax, [eax]                 ;nacita offset skoku
                                                ;jmp prva_API_funkcia(FF25xxxxxxxx)
                                                ;my vlastne nacitame hodnotu xxxxxxxx

                mov  eax, [eax]                 ;z Import table nacita konecne realnu adresu rutiny
                                                ;API funkcie MessageBoxA v pamati


                call VirtualQuery, eax, offset Struktura_pamate, 4*7
                                                ;zavola API funkciu VirtualQuery s parametrami:
                                                ;eax = adresa rutiny MessageBoxA v pamati
                                                ;offset Struktura_pamate = offset buffera pre navratove hodnoty
                                                ;4*7 = velkost buffera v dword (slovach)                                                        ;pomocou tohto volania zisti adresu vlastnika API funkcie
                                                ;MessageBoxA. Adresa bude v buffery na offsete pvAllocBase

                call GetModuleHandleA, offset Vlastnik
                                                ;zisti adresu DLL, ktora ma API funkciu MessageBoxA vlastnit (USER32.DLL)

                push eax                        ;ulozi navratovu hodnotu

;----------------------------------------------------------------------------
;NASTAVI PREDCHADZAJUCU OBSLUHU SEH
;----------------------------------------------------------------------------
                push dword ptr [predchadzajuca]
                call SetUnhandledExceptionFilter
;----------------------------------------------------------------------------

                pop  eax                        ;obnovi navratovu hodnotu

                test eax,eax
                jz   continiue                  ;ak bola chyba a eax=0, tak skoci

                cmp  eax, [pvAllocBase]         ;porovna, ci je naozaj vlastnikom spravny modul
                jnz  skok                       ;ak sa nerovnaju skoci, pretoze nasiel API hook danej funkcie


continiue:
                call MessageBoxA,0, offset sprava2, offset sprava1,0
                call ExitProcess, -1

skok:

                call MessageBoxA,0, offset sprava3, offset sprava1,0
                call ExitProcess, -1




chyba:                                          ;nova obsluha SEH pre pripad chyby

                mov  esp, [odlozESP]
                push offset continiue
                ret


Detekcia:                                       ;toto navestie moze byt kdekolvek, kde sa nachadza
                                                ;volana API funkcia MessageBoxA.
                call    MessageBoxA



ends
end Start
