#include <stdio.h>
#define WIN32_LEAN_AND_MEAN
#include <windows.h>


BOOL IsSoftIce95Loaded()
{
	HANDLE hFile;  
 
	// "\\.\SICE" pre Windows 9x
	hFile = CreateFile( "\\\\.\\SICE",	
						GENERIC_READ | GENERIC_WRITE,
						FILE_SHARE_READ | FILE_SHARE_WRITE,
						NULL,
						OPEN_EXISTING,
						FILE_ATTRIBUTE_NORMAL,
						NULL);

	if( hFile != INVALID_HANDLE_VALUE )
	{
		CloseHandle(hFile);
		return TRUE;
	}

	return FALSE;
}


BOOL IsSoftIceNTLoaded()
{
	HANDLE hFile;  
 
	// "\\.\NTICE" pre Windows NT
	hFile = CreateFile( "\\\\.\\NTICE",
						GENERIC_READ | GENERIC_WRITE,
						FILE_SHARE_READ | FILE_SHARE_WRITE,
						NULL,
						OPEN_EXISTING,
						FILE_ATTRIBUTE_NORMAL,
						NULL);

	if( hFile != INVALID_HANDLE_VALUE )
	{
		CloseHandle(hFile);
		return TRUE;
	}

	return FALSE;
}


	
int main(void)
{
	if( IsSoftIce95Loaded() )
		printf("SoftICE pre Windows 9x je aktivny v pamati.\n");
	else if( IsSoftIceNTLoaded() )
		printf("SoftICE for Windows NT a 2000 je aktivny v pamati.\n");
	else
		printf("SoftICE nebol najdeny.\n");

	return 0;
}