#include <windows.h>
#include <stdio.h>
#include "Resource.h"

/*-----------------------------------------------------------*/

int APIENTRY MyDlgProc(HWND,WORD,LONG,LONG);
BOOL TestSerial(HWND);

/*-----------------------------------------------------------*/

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine,int nCmdShow) {

  UNREFERENCED_PARAMETER(nCmdShow);
  UNREFERENCED_PARAMETER(lpCmdLine);
  UNREFERENCED_PARAMETER(hPrevInstance);

  return(DialogBox((HANDLE)hInstance,(LPCSTR)"Serial1",NULL,(DLGPROC)MyDlgProc));
}

/*-----------------------------------------------------------*/

int APIENTRY MyDlgProc(HWND hDlg, WORD wMsg, LONG wParam, LONG lParam) {

  UNREFERENCED_PARAMETER(lParam);

  switch(wMsg) {
    case WM_INITDIALOG:
      SendDlgItemMessage(hDlg,MY_EDIT1,EM_SETLIMITTEXT,(WPARAM)60,0);
      break;

    case WM_SYSCOMMAND:
      if(wParam == SC_CLOSE)  {
        EndDialog(hDlg,TRUE);
        return (TRUE);
      }
      break;

    case WM_COMMAND:
      switch(LOWORD(wParam)) {
        case MY_BUTTON_REG:
          if(HIWORD(wParam)==BN_CLICKED) {
            if(TestSerial(hDlg))
              MessageBox(hDlg,"Sriov slo je v podku. Dkujeme za registraci.","Registrace",MB_ICONINFORMATION);
            else
              MessageBox(hDlg,"patn sriov slo, zkuste to znovu","Registrace",MB_ICONSTOP);
          }
          break;

        case MY_BUTTON_CAN:
          if(HIWORD(wParam)==BN_CLICKED)
            PostQuitMessage(0);
          break;
      }
  }

  return(FALSE);
}

/*-----------------------------------------------------------*/

BOOL TestSerial(HWND hDlg) {
char* Serial=(char*)malloc(100*sizeof(char));
char* Buffer=(char*)malloc(10*sizeof(char));

BOOL RetValue = FALSE;
BYTE CRC = 0x00;

unsigned Delka;
unsigned i;

  if((Delka = GetDlgItemText(hDlg,MY_EDIT1,Serial,100)) == 15) {
    do {
      if(strncmp(Serial,"MEGA-",5) != 0)
        break;

      for(i=5;i<13;i++)
        CRC = ((CRC << 1) ^ Serial[i]) & 0xFF;

      sprintf(Buffer,"%02X\0",CRC);

      if(strcmp(Buffer,Serial+13) != 0)
        break;

      RetValue = TRUE;
    } while(FALSE);
  }

  free(Serial);
  free(Buffer);

  return RetValue;
}

// Sprvne registran slo je MEGA-1234567806

/*-----------------------------------------------------------*/
