.386
.MODEL FLAT,STDCALL
locals
jumps
UNICODE=0
includelib advapi32.lib
include w32.inc


Extrn SetUnhandledExceptionFilter : PROC
Extrn RegOpenKeyExA               : PROC        ;exportovana funkcia z ADVAPI32.DLL
Extrn RegQueryValueExA            : PROC        ;exportovana funkcia z ADVAPI32.DLL

.DATA

sprava1        db "Najdenie instalacneho adresara Soft-Ice pomocou registrov",0
sprava3        db "Soft-Ice najdeny",0
sprava2        db "Soft-Ice nenasiel",0
sprava4        db "Soft-Ice je nainstalovany v adresari:",0
sprava5        db "Nainstalovana verzia Soft-Ice:",0
odlozESP       dd 0                             ;sem uklada register ESP
predchadzajuca dd 0                             ;sem uklada adresu predchadzajucej obsluhy SEH
result         dd 0
velkost        dd 5                             ;velkost datoveho buffera pre verziu Soft-Ice
velkost2       dd 80h                           ;velkost datoveho buffera pre instalacny adresar Soft-Ice
subkey         db "Software\NuMega\SoftIce\",0
current_ver    db "Current Version",0
install_dir    db "InstallDir",0
data_buffer    db 200 dup (0)                   ;sem uklada verziu nainstalovaneho Soft-Ice
value_buffer   db  20 dup (0)
data_buffer2   db 200 dup (0)                   ;sem uklada kde je Soft-Ice nainstalovany

.CODE
Start:

;----------------------------------------------------------------------------
;NASTAVI SEH PRE PRIPAD CHYBY
;----------------------------------------------------------------------------
                mov  [odlozESP],esp
                push offset chyba
                call SetUnhandledExceptionFilter
                mov  [predchadzajuca], eax
;----------------------------------------------------------------------------

                push offset result              ;kam ulozi vysledok (rukovat)
                push 20019h                     ;typ pristupu
                push 0                          ;nepodstatne (musi byt 0)
                push offset subkey              ;retazec s nazvom subkey
                push 80000002h                  ;HKEY_LOCAL_MACHINE = 80000002 kde otvori subkey
                call RegOpenKeyExA              ;otvori v registroch pozadovany pristup a do result ulozi vysledok (rukovat) pre dalsiu manipulaciu

                test eax,eax
                jnz  nenasiel                   ;ak bola chyba skok


                push offset velkost             ;velkost datoveho buffera
                push offset data_buffer         ;adresa pre datovy buffer
                push offset value_buffer        ;adresa pre buffer hodnot
                push 0                          ;nepodstatne (musi byt 0)
                push offset current_ver         ;meno hodnoty na porovanie (Current Version)
                push result                     ;kam ulozil vysledok (rukovat)
                call RegQueryValueExA           ;nacita do data_buffer nainstalovanu verziu Soft-Ice

                test eax,eax
                jnz  nenasiel                   ;ak bola chyba skok


                push offset velkost2            ;velkost datoveho buffera
                push offset data_buffer2        ;adresa pre datovy buffer
                push offset value_buffer        ;adresa pre buffer hodnot
                push 0                          ;nepodstatne (musi byt 0)
                push offset install_dir         ;meno hodnoty na porovnanie
                push result                     ;kam ulozil vysledok (rukovat)
                call RegQueryValueExA           ;nacita do data_buffer2 instalacky adresar Soft-Ice

                test eax,eax
                jnz  nenasiel                   ;ak bola chyba skok

                inc  al                         ;zvisi register al o 1 (ak nebola chyba, tak je eax=0) na znak ze vsetko prebehlo v poriadku
                jmp  short ok


nenasiel:
                xor  eax,eax                    ;nuluje register eax na znak ze bola chyba

ok:
                push eax                        ;ulozi vysledok

;----------------------------------------------------------------------------
;NASTAVI PREDCHADZAJUCU OBSLUHU SEH
;----------------------------------------------------------------------------
                push dword ptr [predchadzajuca]
                call SetUnhandledExceptionFilter
;----------------------------------------------------------------------------

                pop  eax                        ;obnovi vysledok

                test eax,eax
                jnz  skok                       ;ak vsetko prebehlo v poriadku, tak skoci


continiue:
                call MessageBoxA,0, offset sprava2, offset sprava1,0
                call ExitProcess, -1

skok:

                call MessageBoxA,0, offset sprava3, offset sprava1,0
                                                ;vypise spravu, ze Soft-Ice nasiel

                call MessageBoxA,0, offset data_buffer, offset sprava5,0
                                                ;vypise cislo nainstalovanej verzie Soft-Ice

                call MessageBoxA,0, offset data_buffer2, offset sprava4,0
                                                ;vypise adresar, kde je Soft-Ice nainstalovany

                call ExitProcess, -1




chyba:                                          ;nova obsluha SEH pre pripad chyby

                mov  esp, [odlozESP]
                push offset continiue
                ret


ends
end Start
