.386
.MODEL FLAT,STDCALL
locals
jumps
UNICODE=0
include w32.inc


;nie je potrebne ziadne API volanie

.data

sprava1        db "Spustanie prikazov BCHK rozhrania Soft-Ice",0
sprava3        db "Soft-Ice prikazy funkcne",0
sprava2        db "Soft-Ice nie je aktivny,  nastala chyba, program bol krokovany alebo su nastavene breapointy",0
znacka         db 0                             ;znacka, ci vsetko prebehlo v poriadku

.code

Start:
                xor  eax,eax                    ;nuluje register eax
                call real_start                 ;skoci na realny start programu

;----------------------------------------------------------------------------
;NOVA OBSLUHA SEH PRE PRIPAD CHYBY
;----------------------------------------------------------------------------
                mov  ecx, [esp+0ch]             ;nacita adresu context
                sub  eax,eax
                inc  dword ptr [ecx+0B8h]       ;zvisi v context register EIP o 1 a tym sa posunie o 1 byte v programe
                inc  byte ptr znacka            ;nastavi znacku na hodnotu 1, na znak, e vsetko prebehlo v poriadku. Ak tam bude
                                                ;ina hodnota ako 1, znamena to, ze bola nasa obsluha SEH volan viackrat, o je
                                                ;zle a znamena to, ze Soft-Ice nie je aktivny v pamati. Pripadne ak je znacka 0 nebola
                                                ;volana vobec, o je tiez zle a znamena to, ze bol program krokovany.
                ret                             ;vrati sa z obsluhy SEH spat do programu
;----------------------------------------------------------------------------

real_start:
                push dword ptr fs:[eax]         ;ulozi povodnu obsluhu SEH
                mov  dword ptr fs:[eax], esp    ;nastavi nasu novu obsluhu SEH (preto sme skocili pomocou CALL aby do stacku ulozil adresu za nim (navratova adresa) a to je nasa nova obsluha SEH


                mov  eax,4                      ;"magicke" hodnoty na zistenie,
                mov  ebp,"BCHK"                 ;ci je Soft-Ice aktivny
                int  3h                         ;vola prerusenie INT 3h (ak nie je Soft-Ice aktivny, nastane chyba a je volana nasa nova obsluha SEH)

                cmp  eax,4                      ;testuje, ci bolo eax zmenene,
                jz   continiue                  ;ak nie, Soft-Ice nie je aktivny v pamati a skoci


                mov  eax, 0                     ;funkcia Get ID (vrati ID pre Soft-Ice)
                mov  ebp,"BCHK"                 ;bude volane BCHK rozhranie
                int  3h                         ;vola Soft-Ice

                cmp  eax, 0ff01h                ;testuje, ci je navratova hodnota 0FF01h
                jnz  continiue                  ;ak nie, Soft-Ice nie je aktivny v pamati

                sub  edi,edi                    ;znacka, ci je potrebne deaktivovat, nastavime ju na 0, co znamena, ze nie
                mov  eax,8                      ;funkcia Deactivate Lowest Breakpoint (deaktivuje najnizsi breakpoint)
                int  3h                         ;vola Soft-Ice

                inc  eax                        ;vrati -1 (0FFFFFFFFh), ak bola chyba
                jz   netreba                    ;skoci ak bola chyba a nie je potrebne deaktivovat breakpointy

                dec  edi                        ;nastavi, ze je potrebne breakpointy deaktivovat
                dec  eax                        ;vrati do eax hodnotu chyby (-1)
                xchg eax,ebx                    ;vymeni hodnoty v registroch
netreba:

                mov  ecx, cs                    ;selektor (segment) breakpointu
                lea  edx, breakpoint            ;adresa kam nastavime breakpoint
                mov  bh, 0+0                    ;0-typ breakpointu (BT_EXECUTE) + 0-dlzka breakpontu (BL_BYTE)
                mov  eax, 0ah                   ;funkcia Set Breakpoint (nastavi breakpoint)
                int  3h                         ;vola Soft-Ice

                mov  eax,9                      ;funkcia Activate breakpoint (aktivuje breakpointy, hoci oni su standartne aktivovane hned po vytvoreni, ale istota je istota)
                int  3h                         ;vola Soft-Ice

                nop

breakpoint:
                nop                             ;na tomto mieste sa Soft-Ice pri krokovani zasekne alebo tu nastane chyba a program vola nasu novu obsluhu SEH.

                mov  eax, 0ch                   ;funkcia Get Breakpoint Status (ulozi do registra eax register DR6)
                int  3h                         ;vola Soft-Ice

                push eax                        ;ulozi status (DR6)

                mov  eax, 0bh                   ;funkcia Clear Breakpoint (odstrani breakpoint)
                int  3h                         ;vola Soft-Ice

                inc  edi
                je   netreba2                   ;testuje, ci je potrebne deaktivovat breakpoint

                mov  eax,8                      ;funkcia Deactivate Lowest Breakpoint (deaktivuje najnizsi breakpoint)
                int  3h                         ;vola Soft-Ice
netreba2:

                pop  ecx                        ;obnovi status (DR6)

                xor  eax,eax
                pop  dword ptr fs:[eax]         ;nastavi povodnu obsluhu SEH
                pop  eax                        ;vycisti stack

                xchg eax,ecx                    ;da do eax status

;                bsf  eax,eax                   ;TASM ma pri preklade tejto instrukcie problemy, preto napiseme rovno jej bytovy tvar
                db   0fh, 0bch, 0c0h            ;testuje, ci nebol krokovany, ak ano v eax bude ina hodnota ako 0

                cmp  byte ptr znacka, 1
                jnz  continiue                  ;testuje, ci nebola chyba

                cmp  al,bl                      ;testuje, ci bolo vsetko v poriadku
                jz   skok                       ;ak ano skok

continiue:
                call MessageBoxA,0, offset sprava2, offset sprava1,0
                call ExitProcess, -1

skok:

                call MessageBoxA,0, offset sprava3, offset sprava1,0
                call ExitProcess, -1



ends
end Start
