.386
.MODEL FLAT,STDCALL
locals
jumps
UNICODE=0
include w32.inc

Extrn SetUnhandledExceptionFilter : PROC

.data

sprava1        db "Detekcia breakpointov hladanim Int 3h",0
sprava3        db "Breakpoint najdeny",0
sprava2        db "Breakpoint nenasiel",0
odlozESP       dd 0                             ;sem uklada register ESP
predchadzajuca dd 0                             ;sem uklada adresu predchadzajucej obsluhy SEH
aktualny_import dd 0                            ;sem uklada adresu aktualne testovanej importovanej funkcie

.code

Start:

;----------------------------------------------------------------------------
;NASTAVI SEH PRE PRIPAD CHYBY
;----------------------------------------------------------------------------
                mov  [odlozESP],esp
                push offset chyba
                call SetUnhandledExceptionFilter
                mov  [predchadzajuca], eax
;----------------------------------------------------------------------------

                lea  edi, Start                 ;do edi dame adresu startu programu

                mov  ecx, Koniec-Start+1        ;do ecx dlzku programu, cize pocet testovanych bytov

                mov  eax, 0BCh
                add  eax, 10h                   ;do eax, dame 0CCh (co je prefix instrukcie INT 3h), pozor nesmieme pouzit mov eax, 0CCh, pretoze by sme v programe nasli tuto hodnotu a mysleli by sme si, ze je to breakpoint

                repnz scasb                     ;hlada v programe  breakpoint

                test ecx,ecx                    ;testuje, ci je ecx=0, ak nie nasiel breakpoint

                jne  nasiel                     ;a skoci

                lea  eax, Importy+2             ;do registra eax da adresu na IAT (prvu funkciu)

                mov  dword ptr [aktualny_import], eax

start_hladania:

                mov  eax, dword ptr [aktualny_import]  ;do eax da importovanu funkciu, ktoru bude testovat

                cmp  dword ptr [eax], 0         ;testuje, ci je 0, ak ano je to koniec Import table (tabulky importovanych funkcii)

                je   nenasiel                   ;skoci, ak nenasiel ziadny breakpoint

                mov  ecx, [eax]                 ;nacita adresu kde je ulozena adresa importovanej funkcie, cize adresa zaciatku jej rutiny

                mov  ecx, [ecx]                 ;nacita adresu zaciatku rutiny importovanej funkcie

                mov  eax, 0BCh
                add  eax, 10h                   ;do registra eax dame 0CCh (co je prefix instrukcie INT 3h), pozor nesmieme pouzit mov eax, 0CCh, pretoze by sme v programe nasli tuto hodnotu a mysleli by sme si, ze je to breakpoint

                cmp  byte ptr [ecx], al         ;testuje pritomnost breakpointu v testovanej importovanej funkcii. Hladame na zaciatku jej rutiny hodnotu 0CCh, co je vlastne Int 3h.

                je   nasiel                     ;ak nasiel breakpoint skoci

                add  [aktualny_import], 6       ;nastavi sa na dalsiu importovanu funkciu v IAT

                jmp  start_hladania             ;skok hladat breakpoint v dalsej importovanej funkcii

nasiel:
                mov  eax, 1                     ;nastavi do eax 1 na znak, ze nasiel breakpoint

                jmp  dalej

nenasiel:
                xor  eax, eax                   ;nastavi do eax 0 na znak, ze nenasiel breakpoint

dalej:
                push eax                        ;ulozi navratovu hodnotu

;----------------------------------------------------------------------------
;NASTAVI PREDCHADZAJUCU OBSLUHU SEH
;----------------------------------------------------------------------------
                push dword ptr [predchadzajuca]
                call SetUnhandledExceptionFilter
;----------------------------------------------------------------------------

                pop  eax                        ;obnovi navratovu hodnotu

                test eax, eax

                jnz  skok

continiue:
                call MessageBoxA,0, offset sprava2, offset sprava1,0
                call ExitProcess, -1

skok:

                call MessageBoxA,0, offset sprava3, offset sprava1,0
                call ExitProcess, -1




chyba:                                          ;nova obsluha SEH pre pripad chyby

                mov  esp, [odlozESP]
                push offset continiue
                ret
Koniec:
Importy:                                        ;toto navestie musi byt uplne na konci programu, pretoze tam zacina IAT

ends
end Start
