.386
.MODEL FLAT,STDCALL
locals
jumps
UNICODE=0
include w32.inc


Extrn SetUnhandledExceptionFilter : PROC
Extrn GetProcAddress              : PROC
Extrn LoadLibraryA                : PROC

.data

sprava1        db "Detekcia s vyuzitim nmtrans.dll",0
sprava3        db "Soft-Ice najdeny",0
sprava2        db "Soft-Ice nenasiel",0
odlozESP       dd 0                             ;sem uklada register ESP
predchadzajuca dd 0                             ;sem uklada adresu predchadzajucej obsluhy SEH
SOFT95sym      db "C:\programy\sice\SoftICE\nmtrans.dll",0     ;cestu je potrebne upravit podla instalacie soft-ice
SOFTNTsym      db "C:\programy\NTICE\nmtrans.dll",0            ;to sa da napriklad pomocou citania z registrov
SOFTsym        db "NmSymIsSoftICELoaded",0      ;meno funkcie v nmtrans.dll



.code

Start:

;----------------------------------------------------------------------------
;NASTAVI SEH PRE PRIPAD CHYBY
;----------------------------------------------------------------------------
                mov  [odlozESP],esp
                push offset chyba
                call SetUnhandledExceptionFilter
                mov  [predchadzajuca], eax
;----------------------------------------------------------------------------

                call LoadLibraryA, offset SOFT95sym            ;nahra dll (nmtrans.dll) pre Soft-Ice Windows 9x

                test eax, eax
                jz   nieje95                                   ;skok, ak bola chyba

                call GetProcAddress, eax, offset SOFTsym       ;zisti adresu funkcie NmSymIsSoftICELoaded

                test eax, eax
                jz   nieje95                                   ;skok, ak bola chyba


                call eax                                       ;vola funkciu NmSymIsSoftICELoaded, v EAX je jej adresa

                test eax,eax                                   ;skok, ak eax nie je 0. To znamena,
                jnz  exit                                      ;ze Soft-Ice je aktivny v pamati



nieje95:

                call LoadLibraryA, offset SOFTNTsym           ;nahra dll (nmtrans.dll) pre Soft-Ice Windows NT a 2000

                test eax,eax
                jz   exit                                     ;ak bola chyba skok


                call GetProcAddress, eax, offset SOFTsym      ;zisti adresu funkcie NmSymIsSoftICELoaded

                test eax,eax
                jz   exit                                     ;ak bola chyba skok

                call eax                                      ;vola funkciu NmSymIsSoftICELoaded, v EAX je jej adresa

exit:


                push eax                                      ;ulozi navratovu hodnotu

;----------------------------------------------------------------------------
;NASTAVI PREDCHADZAJUCU OBSLUHU SEH
;----------------------------------------------------------------------------
                push dword ptr [predchadzajuca]
                call SetUnhandledExceptionFilter
;----------------------------------------------------------------------------

                pop  eax                                      ;obnovi navratovu hodnotu

                test eax,eax                                  ;ak EAX nebude 0, tak Soft-Ice je aktivny v pamati
                jnz  skok                                     ;a skoci



continiue:
                call MessageBoxA,0, offset sprava2, offset sprava1,0
                call ExitProcess, -1

skok:

                call MessageBoxA,0, offset sprava3, offset sprava1,0
                call ExitProcess, -1




chyba:                                          ;nova obsluha SEH pre pripad chyby

                mov  esp, [odlozESP]
                push offset continiue
                ret



ends
end Start
